#include <stdio.h>
#include <stdlib.h>

#define MAXBC 127
#define MAXAZ 100

int freadv (FILE *fh, double x[], int maxdim)
{
  int n = 0;
  char buf[MAXBC+1];
  while (fgets(buf,MAXBC+1,fh) != NULL)
  {
    double y;
    if (sscanf(buf,"%lf", &y) != 1)
      return 0;
    if (n >= maxdim)
      return 0;
    x[n] = y;
    n++;
  }
  return n;
}


FILE *apri_file (char *nome_file, char *modo)
{
  FILE *fh;

  if ((fh=fopen(nome_file,modo)) == NULL) {
    fprintf (stderr, "errore - impossibile aprire il file '%s' in '%s'\n",
      nome_file, (modo[0]=='r')?"lettura":"scrittura");
    exit (1);
  }
  return fh;
}


int main (int argc, char *argv[])
{
  double valaz[MAXAZ];
  FILE *afh;
  char buf[MAXBC+1];
  int n_azioni;

  /* controllo parametri sulla linea di comando */

  if (argc != 2) {
     fprintf (stderr, "errore - fornire il nome del file\n");
     exit (1);
  }

  /* lettura del file e caricamento dati nel vettore valaz[] */

  afh = apri_file (argv[1],"r");

  n_azioni = freadv (afh, valaz, MAXAZ);
  if (n_azioni < 1) {
    fprintf (stderr, "errore - il file '%s' non contiene dati\n", argv[1]);
    exit (2);
  }

  if (fclose(afh) != 0)
    fprintf (stderr, "avviso - chiusura del file '%s' fallita\n", argv[1]);

  /* lettura indici delle azioni e presentazione valori */

  while (gets(buf) != NULL)
  {
    int iaz;
    if (sscanf(buf,"%d",&iaz) != 1)
      fprintf (stderr, "errore - indicare l'indice di un'azione\n");
    else
    {
      if (iaz < 1 || iaz > n_azioni)
        fprintf (stderr, "errore - azione sconosciuta (n.%d)\n", iaz);
      else
        printf ("quotazione dell'azione n.%d = %.2lf\n", iaz, valaz[iaz-1]);
    }
  }

  return 0;
}
