#include <stdio.h>
#include <stdlib.h>

#define MAXBC 127



FILE *apri_file (char *nome_file, char *modo)
{
  FILE *fh;

  if ((fh=fopen(nome_file,modo)) == NULL) {
    fprintf (stderr, "errore - impossibile aprire il file '%s' in '%s'\n",
      nome_file, (modo[0]=='r')?"lettura":"scrittura");
    exit (1);
  }
  return fh;
}


int main (int argc, char *argv[])
{
  FILE *afh;
  char buf[MAXBC+1];
  unsigned iaz;
  unsigned nriga = 1;

  if (argc != 3) {
    fprintf (stderr, "errore - fornire il nome del file e l'indice dell'azione\n");
    exit (1);
  }

  afh = apri_file (argv[1],"r");

  if (sscanf(argv[2],"%u",&iaz) != 1) {
    fprintf (stderr, "errore - indice non valido (%s)\n", argv[2]);
    exit (1);
  }

  while (fgets(buf,MAXBC+1,afh) != NULL)
  {
    if (nriga == iaz)
    {
      double valore;
      if (sscanf(buf,"%lf", &valore) != 1)
      {
        fprintf (stderr, "errore: riga non contiene valore azione\n");
        exit (1);
      }
      printf ("quotazione dell'azione n.%d = %.2lf\n", iaz, valore);
      break;
    }
    nriga++;
  }

  if (iaz >= nriga)
    printf ("azione inesistente\n");

  if (fclose(afh) != 0)
    fprintf (stderr, "avviso - chiusura del file '%s' fallita\n", argv[1]);

  return 0;
}
