#include <stdio.h>
#include <stdlib.h>

int copia_riga (FILE *f1, FILE *f2)
{
  int xc;
  while ((xc = fgetc(f1)) != '\n')
  {
    if (xc == EOF)
      return EOF;
    fputc (xc, f2);
  }
  fputc ('\n', f2);
  return 0;
}


int main (int argc, char *argv[])
{
  int n, righe_copiate;
  FILE *afh, *bfh;

  if (argc != 4) {
    fprintf (stderr, "errore: inserire numero di righe da copiare e nomi di due file\n");
    exit(1);
  }
  if (sscanf(argv[1],"%d",&n) != 1) {
    fprintf (stderr, "errore: il parametro (%s) non e` un numero intero\n", argv[1]);
    exit(2);
  }
  if ((afh=fopen(argv[2],"r")) == NULL) {
    fprintf (stderr, "errore: impossibile aprire il file '%s' in lettura\n", argv[2]);
    exit(3);
  }
  if ((bfh=fopen(argv[3],"w")) == NULL) {
    fprintf (stderr, "errore: impossibile aprire il file '%s' in scrittura\n", argv[3]);
    exit(4);
  }

  righe_copiate = 0;

  while ( (righe_copiate < n) && (copia_riga(afh,bfh) != EOF) )
    righe_copiate++;

  if (fclose(afh) != 0)
    fprintf (stderr, "avviso: non sono riuscito a chiudere il file '%s'\n", argv[2]);
  if (fclose(bfh) != 0) {
    fprintf (stderr, "avviso: non sono riuscito a chiudere il file '%s';", argv[3]);
    fprintf (stderr, " la copia potrebbe non essere riuscita\n");
  }

  if (righe_copiate < n)
    fprintf (stderr, "avviso - copiate solo %d righe (invece di %d)\n", righe_copiate, n);

  return 0;
}
