#include <stdio.h>
#include <stdlib.h>
#include <math.h>

#define MAX_DATI 200
#define MAXBC 127

int freadv (FILE *fh, double x[], const int maxdim)
{
  int ndim = 0;
  char buf[MAXBC+1];

  while (fgets(buf,MAXBC+1,fh) != NULL)
  {
    double y;
    if (sscanf(buf,"%lf", &y) != 1)
      return 0;
    if (ndim >= maxdim)
      return 0;
    x[ndim++] = y;
  }
  return ndim;
}


int main (int argc, char *argv[])
{
  FILE *afh;
  double v[MAX_DATI];
  int i, ndati;
  double media, totv = 0;

  /* controllo dei dati */

  if (argc != 2)
  {
    fprintf (stderr, "errore: manca il nome del file\n");
    exit (1);
  }

  /* apertura del file */

  if ((afh=fopen(argv[1],"r")) == NULL) {
    fprintf (stderr, "errore: impossibile aprire il file '%s' in lettura\n", argv[1]);
    exit (2);
  }

  /* lettura dei dati dal file */

  ndati = freadv (afh, v, MAX_DATI);

  if (fclose(afh))
    fprintf (stderr, "avviso: non riesco a chiudere il file %s\n", argv[1]);

  if (ndati == 0)
  {
    fprintf (stderr, "errore: file dati scorretto\n");
    exit (3);
  }

  /* calcolo della media */

  for (i=0; i<ndati; i++)
    totv += v[i];

  media = totv / ndati;

  /* stampa dei valori */

  printf ("media = %lf\n", media);

  for (i=0; i<ndati; i++)
  {
    double diff = fabs ( v[i]-media );

    if (diff > 0.5 * media)
      printf ("*** %lf\n", v[i]);
    else if (diff > 0.3 * media)
      printf (" ** %lf\n", v[i]);
    else if (diff > 0.1 * media)
      printf ("  * %lf\n", v[i]);
    else
      printf ("    %lf\n", v[i]);
  }

  /* fine del programma */

  return 0;
}
