/******************************************

MODULO: eq2g.c

SCOPO: equazione di II grado

******************************************/

#include <stdio.h>
#include <math.h>
#include <stdlib.h>

#define MAXBC 127

int main ()
{
  char
    buf[MAXBC+1]; /* buffer di input */
  double
    a, b, c; /* coefficienti */

  printf ("Equazione di II grado\n");
  printf ("A B C? ");
  if (gets(buf) == NULL)
    exit (1);

  /* controllo dell'input */

  if (sscanf (buf, "%lf %lf %lf", &a, &b, &c) != 3)
  {
    fprintf (stderr, "errore - fornire i tre coefficienti dell'equazione\n");
    exit (2);
  }

  if (a == 0.0) /* equazione di primo grado */
  {
    if (b == 0.0)
    {
      if (c == 0.0)
        printf ("equazione indeterminata\n");
      else
        printf ("equazione impossibile\n");
    }
    else
      printf ("x = %lf\n", -c/b);
  }

  else /* equazione di secondo grado */
  {
    double d = b*b - 4*a*c; /* discriminante */
    if (d == 0.0)
      printf ("x1 = x2 = %lf\n", -b/(2*a));
    else if (d > 0)
    {
      printf ("x1 = %lf\n", (-b+sqrt(d))/(2*a));
      printf ("x2 = %lf\n", (-b-sqrt(d))/(2*a));
    }
    else /* d < 0 */
    {
      double re = -b / (2 * a);
      double im = fabs( sqrt(-d) / (2 * a) );
      printf ("x1 = %lf + i %lf\n", re, im);
      printf ("x2 = %lf - i %lf\n", re, im);
    }
  }
  return 0;
}
