#include <stdio.h>
#include <stdlib.h>

#define MAXBC 127
#define NPROD 20
#define FPREZ "PREZZI.TXT"

int main ()
{
  double prezzo[NPROD];
  FILE *afh;
  char buf[MAXBC+1];
  int i, iprod, qprod;
  double riprod, ritot;

  /* apertura del file */

  afh = fopen (FPREZ, "r");
  if (afh == NULL)
  {
    fprintf (stderr, "errore - impossibile aprire il file '%s' in lettura\n", FPREZ);
    exit (1);
  }

  /* lettura dei prezzi dal file - freadvfix (afh, prezzo, NPROD) */

  for (i=0; i<NPROD; i++)
  {
    if (fgets (buf, MAXBC+1, afh) == NULL)
    {
      fprintf (stderr, "errore - mancano dati nel file '%s'\n", FPREZ);
      fclose (afh);
      exit (2);
    }
    if (sscanf(buf,"%lf",&prezzo[i]) != 1)
    {
      fprintf (stderr, "errore - formato del prezzo errato (%s)\n", buf);
      fclose (afh);
      exit (3);
    }
  }

  /* chiusura del file */

  if (fclose(afh) != 0)
    fprintf (stderr, "avviso - errore nella chiusura del file '%s'\n", FPREZ);

  /* lettura dei dati di vendita e calcolo del ricavo */

  ritot = 0;
  while (gets(buf) != NULL)
  {
    if (sscanf(buf, "%d %d", &iprod, &qprod) != 2)
      fprintf (stderr, "errore - formato di vendita sbagliato (%s)\n", buf);
    else if (iprod<1 || iprod>NPROD || qprod<0)
      fprintf (stderr, "errore - formato di vendita sbagliato (%s)\n", buf);
    else
    {
      riprod = qprod * prezzo[iprod-1];
      ritot += riprod;
    }
  }

  /* stampa del risultato */

  printf ("%lf\n", ritot);

  return 0;
}
