/* soluzione esame 21/2/2011 - CON CONTROLLI */

#include <stdio.h>
#include <stdlib.h>
#include <math.h>

#define MAXNOME 20
#define MAXBC 127
#define ARCHIVIO "montagne.txt"

#define BOOLEAN int
#define FALSE 0
#define TRUE (!FALSE)

struct _montagna {
  char nome[MAXNOME+1];
  double latitudine;
  double longitudine;
  long altezza;
};

typedef struct _montagna montagna;
  
double distanza (double x, double y, montagna m)
{
  return sqrt (
    (x - m.latitudine) * (x - m.latitudine)
    +
    (y - m.longitudine) * (y - m.longitudine)
  );
}


int main (int argc, char *argv[])
{
  montagna monte, min_monte;
  double dist, min_dist;
  BOOLEAN primo_monte = TRUE;
  double myLat, myLong;
  FILE *afh;
  char buf[MAXBC+1];

  if (argc != 3) {
    fprintf (stderr, "errore - introdurre latitudine e longitudine\n");
    exit (1);
  }
  if ((sscanf(argv[1],"%lf",&myLat) != 1) || (myLat<-90) || (myLat>90)) {
    fprintf (stderr, "errore - latitudine errata (%s)\n", argv[1]);
    exit (1);
  }
  if ((sscanf(argv[2],"%lf",&myLong) != 1) || (myLong<-180) || (myLong>180)) {
    fprintf (stderr, "errore - longitudine errata (%s)\n", argv[2]);
    exit (1);
  }

  if ((afh=fopen(ARCHIVIO,"r")) == NULL) {
    fprintf (stderr, "errore - impossibile aprire il file %s in lettura\n", ARCHIVIO);
    exit (1);
  }

  while (fgets(buf,MAXBC,afh) != NULL)
  {
    if ((sscanf (buf, "%s %lf %lf %ld",
      &monte.nome, &monte.latitudine, &monte.longitudine, &monte.altezza) != 4)
      || monte.latitudine<-90 || monte.latitudine>90
      || monte.longitudine<-180 || monte.longitudine>180)
      continue;
    dist = distanza (myLat, myLong, monte);
    if (primo_monte)
    {
      min_dist = dist;
      min_monte = monte;
      primo_monte = FALSE;
    }
    else
    {
      if (dist < min_dist)
      {
        min_dist = dist;
        min_monte = monte;
      }
    }
  }

  printf ("Monte piu' vicino: %s (altezza %ld)\n",
    min_monte.nome, min_monte.altezza);

  if (fclose(afh))
    fprintf (stderr, "avviso - fallita chiusura del file %s\n", ARCHIVIO);

  return 0;
}
